package org.bitbucket.bradleysmithllc.etlunit.feature.execute;

import com.google.inject.Injector;
import org.bitbucket.bradleysmithllc.etlunit.feature.AbstractFeature;
import org.bitbucket.bradleysmithllc.etlunit.feature.extend.Extender;

import javax.inject.Inject;
import java.util.Arrays;
import java.util.List;

public class RuntimeExecutorFeatureModule extends AbstractFeature
{
	private ExecuteFeatureModule executeFeatureModule;

	private static final List<String> prerequisites = Arrays.asList("execute");

	@Inject
	public void setExecuteFeatureModule(ExecuteFeatureModule module)
	{
		executeFeatureModule = module;
	}

	@Override
	public void initialize(Injector inj)
	{
		Extender exe = new RuntimeExecutor(this);

		executeFeatureModule.extend(
			postCreate(exe)
		);
	}

	@Override
	public List<String> getPrerequisites() {
		return prerequisites;
	}
}
